<?php
class Services_WTF_Test{const api_url='https://gtmetrix.com/api/0.1';private $username='';private $password='';private $user_agent='Services_WTF_Test_php/0.4 (+http://gtmetrix.com/api/)';protected $test_id='';protected $result=array();protected $error='';public function __construct($username='',$password=''){$this->username=$username;$this->password=$password;}
public function api_username($username){$this->username=$username;}
public function api_password($password){$this->password=$password;}
public function user_agent($user_agent){$this->user_agent=$user_agent;}
protected function query($command,$req='GET',$params=''){$ch=curl_init();if(substr($command,0,strlen(self::api_url)-1)==self::api_url){$URL=$command;}else{$URL=self::api_url.'/'.$command;}
curl_setopt($ch,CURLOPT_URL,$URL);curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);curl_setopt($ch,CURLOPT_HTTPAUTH,CURLAUTH_BASIC);curl_setopt($ch,CURLOPT_USERAGENT,$this->user_agent);curl_setopt($ch,CURLOPT_USERPWD,$this->username.":".$this->password);curl_setopt($ch,CURLOPT_CUSTOMREQUEST,$req);curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);if($req=='POST')
curl_setopt($ch,CURLOPT_POSTFIELDS,$params);$results=curl_exec($ch);if($results===false)
$this->error=curl_error($ch);curl_close($ch);return $results;}
protected function checkid(){if(empty($this->test_id)){$this->error='No test_id! Please start a new test or load an existing test first.';return false;}
return true;}
public function error(){return $this->error;}
public function test($data){if(empty($data)){$this->error='Parameters need to be set to start a new test!';return false;}
if(!isset($data['url'])OR empty($data['url'])){$this->error='No URL given!';return false;}
if(!preg_match('@^https?://@',$data['url'])){$this->error='Bad URL.';return false;}
if(!empty($this->result))
$this->result=array();$data=http_build_query($data);$result=$this->query('test','POST',$data);if($result!=false){$result=json_decode($result,true);if(empty($result['error'])){$this->test_id=$result['test_id'];if(isset($result['state'])AND!empty($result['state']))
$this->result=$result;return $this->test_id;}else{$this->error=$result['error'];}}
return false;}
public function load($test_id){$this->test_id=$test_id;if(!empty($this->result))
$this->result=array();}
public function delete(){if(!$this->checkid())
return false;$command="test/".$this->test_id;$result=$this->query($command,"DELETE");if($result!=false){$result=json_decode($result,true);return($result['message'])?true:false;}
return false;}
public function get_test_id(){return($this->test_id)?$this->test_id:false;}
public function poll_state(){if(!$this->checkid())
return false;if(!empty($this->result)){if($this->result['state']=="completed")
return true;}
$command="test/".$this->test_id;$result=$this->query($command);if($result!=false){$result=json_decode($result,true);if(!empty($result['error'])AND!isset($result['state'])){$this->error=$result['error'];return false;}
$this->result=$result;if($result['state']=='error')
$this->error=$result['error'];return true;}
return false;}
public function state(){if(!$this->checkid())
return false;if(empty($this->result))
return false;return $this->result['state'];}
public function completed(){return($this->state()=='completed')?true:false;}
public function get_results(){sleep(6);$i=1;while($this->poll_state()){if($this->state()=='completed'OR $this->state()=='error')
break;sleep($i++<=13?2:5);}}
public function locations(){$result=$this->query('locations');if($result!=false){$result=json_decode($result,true);if(empty($result['error'])){return $result;}else{$this->error=$result['error'];}}
return false;}
public function results(){if(!$this->completed())
return false;return $this->result['results'];}
public function resources($item='all'){if(!$this->completed())
return false;return $this->result['resources'];}
public function download_resources($items=null,$location='./',$append_test_id=false){if(!$this->completed())
return false;$resources=$this->result['resources'];$resource_types=array('report_pdf'=>'pdf','pagespeed'=>'txt','har'=>'txt','pagespeed_files'=>'tar','yslow'=>'txt','screenshot'=>'jpg',);if(!$items or $items==''){$items=array_keys($resource_types);}
if(!is_array($items)){$items=array($items);}
if(!is_writable($location)){$this->error='Permission denied in '.$location;return false;}
foreach($items as $item){if(!array_key_exists($item,$resources)){$this->error=$item.' does not exist';return false;}
$file=fopen($location.$item.($append_test_id?'-'.$this->test_id:'').'.'.$resource_types[$item],"w");$ch=curl_init();curl_setopt($ch,CURLOPT_URL,$resources[$item]);curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);curl_setopt($ch,CURLOPT_FILE,$file);curl_setopt($ch,CURLOPT_HEADER,0);curl_setopt($ch,CURLOPT_HTTPAUTH,CURLAUTH_BASIC);curl_setopt($ch,CURLOPT_USERAGENT,$this->user_agent);curl_setopt($ch,CURLOPT_USERPWD,$this->username.":".$this->password);curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);$results=curl_exec($ch);if($results===false)
$this->error=curl_error($ch);curl_close($ch);}
return true;}
public function status(){$result=$this->query('status');if($result!=false){$result=json_decode($result,true);if(empty($result['error'])){return $result;}else{$this->error=$result['error'];}}
return false;}}
?>